Index: trunk/lib/FlairSensorActuator/src/SimulatedImu.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedImu.cpp	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedImu.cpp	(revision 286)
@@ -0,0 +1,97 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2014/02/07
+//  filename:   SimulatedImu.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation imu
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedImu.h"
+#include <FrameworkManager.h>
+#include <ImuData.h>
+#include <SpinBox.h>
+#include <GroupBox.h>
+#include <Matrix.h>
+#include <SharedMem.h>
+#include <AhrsData.h>
+#include <sstream>
+
+using std::string;
+using std::ostringstream;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair {
+namespace sensor {
+
+SimulatedImu::SimulatedImu(string name, uint32_t modelId,uint32_t deviceId,
+                 uint8_t priority)
+    : Imu(name,false), Thread(getFrameworkManager(), name, priority) {
+  dataRate =
+      new SpinBox(GetGroupBox()->NewRow(), "data rate", " Hz", 1, 500, 1, 200);
+  ahrsData = new AhrsData((Imu *)this);
+  
+  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId),
+                        sizeof(imu_states_t));
+  SetIsReady(true);
+}
+
+SimulatedImu::~SimulatedImu() {
+  SafeStop();
+  Join();
+}
+
+string SimulatedImu::ShMemName(uint32_t modelId,uint32_t deviceId) {
+  ostringstream dev_name;
+  dev_name << "simu" <<  modelId << "_imu_" << deviceId;
+  return dev_name.str().c_str();
+}
+
+void SimulatedImu::Run(void) {
+  imu_states_t state;
+  ImuData *imuData;
+  GetDatas(&imuData);
+
+  SetPeriodUS((uint32_t)(1000000. / dataRate->Value()));
+
+  while (!ToBeStopped()) {
+    WaitPeriod();
+
+    if (dataRate->ValueChanged() == true) {
+      SetPeriodUS((uint32_t)(1000000. / dataRate->Value()));
+    }
+    shmem->Read((char *)&state, sizeof(imu_states_t));
+    Quaternion quaternion(state.q0, state.q1, state.q2, state.q3);
+    Vector3Df angRate(state.wx, state.wy, state.wz);
+    Vector3Df rawAcc(state.ax, state.ay, state.az);
+    Vector3Df rawMag(state.mx, state.my, state.mz);
+    Vector3Df rawGyr(state.wx, state.wy, state.wz);
+    //we do not need rotation in simulation
+    /*
+    ApplyRotation(angRate);
+    ApplyRotation(quaternion);
+    ApplyRotation(rawAcc);
+    ApplyRotation(rawMag);
+    ApplyRotation(rawGyr);*/
+    ahrsData->SetQuaternionAndAngularRates(quaternion,angRate);
+    imuData->SetRawAccMagAndGyr(rawAcc,rawMag,rawGyr);
+    imuData->SetDataTime(GetTime());
+    ahrsData->SetDataTime(GetTime());
+    ProcessUpdate(ahrsData);
+  }
+}
+
+} // end namespace sensor
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimulatedImu.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedImu.h	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedImu.h	(revision 286)
@@ -0,0 +1,99 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedImu.h
+ * \brief Class for a simulation Imu
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMULATEDIMU_H
+#define SIMULATEDIMU_H
+
+#include <Imu.h>
+#include <Thread.h>
+
+namespace flair {
+  namespace core {
+    class SharedMem;
+    class AhrsData;
+  }
+  namespace gui {
+    class SpinBox;
+  }
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimulatedImu
+*
+* \brief Class for a simulation Imu
+*/
+class SimulatedImu : public Imu, public core::Thread {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimulatedImu.
+	* It will be child of the FrameworkManager.
+  *
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId Imu id of the Model
+  * \param priority priority of the Thread
+  */
+  SimulatedImu(std::string name,
+          uint32_t modelId,uint32_t deviceId, uint8_t priority);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedImu();
+
+private:
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  typedef struct {
+    float q0;
+    float q1;
+    float q2;
+    float q3;
+    float wx;
+    float wy;
+    float wz;
+    float ax;
+    float ay;
+    float az;
+    float mx;
+    float my;
+    float mz;
+  } imu_states_t;
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+
+  gui::SpinBox *dataRate;
+  core::SharedMem *shmem;
+  core::AhrsData *ahrsData;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMULATEDIMU_H
Index: trunk/lib/FlairSensorActuator/src/SimulatedLaser.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedLaser.cpp	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedLaser.cpp	(revision 286)
@@ -0,0 +1,81 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2014/02/07
+//  filename:   SimulatedUs.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation us
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedLaser.h"
+#include <FrameworkManager.h>
+#include <SpinBox.h>
+#include <GroupBox.h>
+#include <Matrix.h>
+#include <SharedMem.h>
+#include <sstream>
+
+using std::string;
+using std::ostringstream;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair {
+namespace sensor {
+
+SimulatedLaser::SimulatedLaser(string name,
+                     uint32_t modelId,uint32_t deviceId, uint8_t priority)
+    : Thread(getFrameworkManager(), name, priority), LaserRangeFinder(name) {
+  data_rate =
+      new SpinBox(GetGroupBox()->NewRow(), "data rate", " Hz", 1, 500, 1, 50);
+
+  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId),
+                        360 * sizeof(float));
+  SetIsReady(true);
+}
+
+SimulatedLaser::~SimulatedLaser() {
+  SafeStop();
+  Join();
+}
+
+string SimulatedLaser::ShMemName(uint32_t modelId,uint32_t deviceId) {
+  ostringstream dev_name;
+  dev_name << "simu" <<  modelId << "_laser_" << deviceId;
+  return dev_name.str().c_str();
+}
+
+void SimulatedLaser::Run(void) {
+  float z[360];
+
+  SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+
+  while (!ToBeStopped()) {
+    WaitPeriod();
+
+    shmem->Read((char *)z, 360 * sizeof(float));
+
+    if (data_rate->ValueChanged() == true) {
+      SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+    }
+    for (int i = 0; i < 360; i++) {
+      output->SetValue(i, 0, z[i]); //*******
+    }
+    output->SetDataTime(GetTime());
+    ProcessUpdate(output);
+  }
+}
+
+} // end namespace sensor
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimulatedLaser.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedLaser.h	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedLaser.h	(revision 286)
@@ -0,0 +1,85 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedUs.h
+ * \brief Class for a simulation UsRangeFinder
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMULATEDLASER_H
+#define SIMULATEDLASER_H
+
+#include <LaserRangeFinder.h>
+#include <Thread.h>
+
+namespace flair {
+namespace core {
+class SharedMem;
+}
+namespace gui {
+class SpinBox;
+}
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimulatedUs
+*
+* \brief Class for a simulation UsRangeFinder
+*/
+class SimulatedLaser : public core::Thread, public LaserRangeFinder {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimulatedUs.
+  *
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId LaserRangeFinder id of the Model
+  * \param priority priority of the Thread
+  */
+  SimulatedLaser(std::string name,
+            uint32_t modelId,uint32_t deviceId, uint8_t priority);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedLaser();
+
+protected:
+  /*!
+  * \brief SharedMem to access datas
+  *
+  */
+  core::SharedMem *shmem;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+  gui::SpinBox *data_rate;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMULATEDLASER_H
Index: trunk/lib/FlairSensorActuator/src/SimulatedPressureSensor.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedPressureSensor.cpp	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedPressureSensor.cpp	(revision 286)
@@ -0,0 +1,80 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2018/05/24
+//  filename:   SimulatedPressureSensor.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation pressure sensor
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedPressureSensor.h"
+#include <FrameworkManager.h>
+#include <SpinBox.h>
+#include <GroupBox.h>
+#include <Matrix.h>
+#include <SharedMem.h>
+#include <sstream>
+
+using std::string;
+using std::ostringstream;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair {
+namespace sensor {
+
+SimulatedPressureSensor::SimulatedPressureSensor(string name, uint32_t modelId,uint32_t deviceId,
+               uint8_t priority)
+    : Thread(getFrameworkManager(), name, priority), PressureSensor( name) {
+  data_rate =
+      new SpinBox(GetGroupBox()->NewRow(), "data rate", " Hz", 1, 500, 1, 50);
+
+  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId), sizeof(float));
+
+  SetIsReady(true);
+}
+
+SimulatedPressureSensor::~SimulatedPressureSensor() {
+  SafeStop();
+  Join();
+}
+
+string SimulatedPressureSensor::ShMemName(uint32_t modelId,uint32_t deviceId) {
+  ostringstream dev_name;
+  dev_name << "simu" <<  modelId << "_pressure_" << deviceId;
+  return dev_name.str().c_str();
+}
+
+void SimulatedPressureSensor::Run(void) {
+  float p;
+
+  SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+
+  while (!ToBeStopped()) {
+    WaitPeriod();
+
+    shmem->Read((char *)&p, sizeof(float));
+
+    if (data_rate->ValueChanged() == true) {
+      SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+    }
+
+    output->SetValue(0, 0, p);
+    output->SetDataTime(GetTime());
+    ProcessUpdate(output);
+  }
+}
+
+} // end namespace sensor
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimulatedPressureSensor.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedPressureSensor.h	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedPressureSensor.h	(revision 286)
@@ -0,0 +1,86 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedPressureSensor.h
+ * \brief Class for a simulation PressureSensor
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2018/05/24
+ * \version 4.0
+ */
+
+#ifndef SIMULATEDPRESSURESENSOR_H
+#define SIMULATEDPRESSURESENSOR_H
+
+#include <PressureSensor.h>
+#include <Thread.h>
+
+namespace flair {
+namespace core {
+class SharedMem;
+}
+namespace gui {
+class SpinBox;
+}
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimulatedPressureSensor
+*
+* \brief Class for a simulation PressureSensor
+*/
+class SimulatedPressureSensor : public core::Thread, public PressureSensor {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimulatedPressureSensor.
+	* It will be child of the FrameworkManager.
+  *
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId PressureSensor id of the Model
+  * \param priority priority of the Thread
+  */
+  SimulatedPressureSensor(std::string name,
+         uint32_t modelId,uint32_t deviceId, uint8_t priority);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedPressureSensor();
+
+protected:
+  /*!
+  * \brief SharedMem to access datas
+  *
+  */
+  core::SharedMem *shmem;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+  gui::SpinBox *data_rate;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMULATEDPRESSURESENSOR_H
Index: trunk/lib/FlairSensorActuator/src/SimulatedUs.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedUs.cpp	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedUs.cpp	(revision 286)
@@ -0,0 +1,80 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+//  created:    2014/02/07
+//  filename:   SimulatedUs.cpp
+//
+//  author:     Guillaume Sanahuja
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    Class for a simulation us
+//
+//
+/*********************************************************************/
+#ifdef CORE2_64
+
+#include "SimulatedUs.h"
+#include <FrameworkManager.h>
+#include <SpinBox.h>
+#include <GroupBox.h>
+#include <Matrix.h>
+#include <SharedMem.h>
+#include <sstream>
+
+using std::string;
+using std::ostringstream;
+using namespace flair::core;
+using namespace flair::gui;
+
+namespace flair {
+namespace sensor {
+
+SimulatedUs::SimulatedUs(string name, uint32_t modelId,uint32_t deviceId,
+               uint8_t priority)
+    : Thread(getFrameworkManager(), name, priority), UsRangeFinder( name) {
+  data_rate =
+      new SpinBox(GetGroupBox()->NewRow(), "data rate", " Hz", 1, 500, 1, 50);
+
+  shmem = new SharedMem((Thread *)this, ShMemName(modelId, deviceId), sizeof(float));
+
+  SetIsReady(true);
+}
+
+SimulatedUs::~SimulatedUs() {
+  SafeStop();
+  Join();
+}
+
+string SimulatedUs::ShMemName(uint32_t modelId,uint32_t deviceId) {
+  ostringstream dev_name;
+  dev_name << "simu" <<  modelId << "_us_" << deviceId;
+  return dev_name.str().c_str();
+}
+
+void SimulatedUs::Run(void) {
+  float z;
+  
+  SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+
+  while (!ToBeStopped()) {
+    WaitPeriod();
+
+    shmem->Read((char *)&z, sizeof(float));
+
+    if (data_rate->ValueChanged() == true) {
+      SetPeriodUS((uint32_t)(1000000. / data_rate->Value()));
+    }
+
+    output->SetValue(0, 0, z);
+    output->SetDataTime(GetTime());
+    ProcessUpdate(output);
+  }
+}
+
+} // end namespace sensor
+} // end namespace flair
+
+#endif
Index: trunk/lib/FlairSensorActuator/src/SimulatedUs.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/SimulatedUs.h	(revision 286)
+++ trunk/lib/FlairSensorActuator/src/SimulatedUs.h	(revision 286)
@@ -0,0 +1,86 @@
+// %flair:license{
+// This file is part of the Flair framework distributed under the
+// CECILL-C License, Version 1.0.
+// %flair:license}
+/*!
+ * \file SimulatedUs.h
+ * \brief Class for a simulation UsRangeFinder
+ * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
+ * \date 2014/02/07
+ * \version 4.0
+ */
+
+#ifndef SIMULATEDUS_H
+#define SIMULATEDUS_H
+
+#include <UsRangeFinder.h>
+#include <Thread.h>
+
+namespace flair {
+namespace core {
+class SharedMem;
+}
+namespace gui {
+class SpinBox;
+}
+}
+
+namespace flair {
+namespace sensor {
+/*! \class SimulatedUs
+*
+* \brief Class for a simulation UsRangeFinder
+*/
+class SimulatedUs : public core::Thread, public UsRangeFinder {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a SimulatedUs.
+	* It will be child of the FrameworkManager.
+  *
+  * \param name name
+  * \param modelId Model id
+  * \param deviceId UsRangeFinder id of the Model
+  * \param priority priority of the Thread
+  */
+  SimulatedUs(std::string name,
+         uint32_t modelId,uint32_t deviceId, uint8_t priority);
+
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SimulatedUs();
+
+protected:
+  /*!
+  * \brief SharedMem to access datas
+  *
+  */
+  core::SharedMem *shmem;
+
+private:
+  /*!
+  * \brief Update using provided datas
+  *
+  * Reimplemented from IODevice.
+  *
+  * \param data data from the parent to process
+  */
+  void UpdateFrom(const core::io_data *data){};
+
+  /*!
+  * \brief Run function
+  *
+  * Reimplemented from Thread.
+  *
+  */
+  void Run(void);
+  
+  std::string ShMemName(uint32_t modelId,uint32_t deviceId);
+  gui::SpinBox *data_rate;
+};
+} // end namespace sensor
+} // end namespace flair
+#endif // SIMULATEDUS_H
Index: trunk/lib/FlairSensorActuator/src/VrpnObject.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/VrpnObject.cpp	(revision 282)
+++ trunk/lib/FlairSensorActuator/src/VrpnObject.cpp	(revision 286)
@@ -18,5 +18,4 @@
 #include "VrpnObject.h"
 #include "VrpnObject_impl.h"
-#include "VrpnClient.h"
 #include <string.h>
 #include <Matrix.h>
@@ -30,7 +29,7 @@
 
 VrpnObject::VrpnObject(string name,
-                       const TabWidget *tab)
-    : IODevice(GetVrpnClient(), name) {
-  pimpl_ = new VrpnObject_impl(this, name, -1, tab);
+                       const TabWidget *tab,VrpnClient *client)
+    : IODevice(client, name) {
+  pimpl_ = new VrpnObject_impl(this, name, -1, tab,client);
   AddDataToLog(pimpl_->output);
   
@@ -39,8 +38,8 @@
 
 VrpnObject::VrpnObject(string name, uint8_t id,
-                       const TabWidget *tab)
-    : IODevice(GetVrpnClient(), name) {
+                       const TabWidget *tab,VrpnClient *client)
+    : IODevice(client, name) {
   Warn("Creation of object %s with id %i\n", name.c_str(), id);
-  pimpl_ = new VrpnObject_impl(this, name, id, tab);
+  pimpl_ = new VrpnObject_impl(this, name, id, tab,client);
   AddDataToLog(pimpl_->output);
   
Index: trunk/lib/FlairSensorActuator/src/VrpnObject.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/VrpnObject.h	(revision 282)
+++ trunk/lib/FlairSensorActuator/src/VrpnObject.h	(revision 286)
@@ -16,4 +16,5 @@
 
 #include <IODevice.h>
+#include <VrpnClient.h>
 #include <Vector3D.h>
 #include <stdint.h>
@@ -32,5 +33,4 @@
 
 class VrpnObject_impl;
-class VrpnClient_impl;
 
 namespace flair {
@@ -45,5 +45,4 @@
 class VrpnObject : public core::IODevice {
   friend class ::VrpnObject_impl;
-  friend class ::VrpnClient_impl;
 
 public:
@@ -55,19 +54,21 @@
   * \param name VRPN object name, should be the same as defined in the server
   * \param tab Tab for the user interface
+  * \param client VrpnClient of the connection, if unspecified, use the default one
   */
   VrpnObject(std::string name,
-             const gui::TabWidget *tab);
+             const gui::TabWidget *tab,sensor::VrpnClient *client=GetVrpnClient());
 
   /*!
   * \brief Constructor
   *
-  * Construct a VrpnObject. Connection is done by IP.
+  * Construct a VrpnObject. Connection is done by xbee.
   *
   * \param name name
-  * \param id VRPN object id, should be the same as defined in the server
+  * \param id VRPN object id, should be the same as defined in the xbee bridge
   * \param tab Tab for the user interface
+  * \param client VrpnClient of the connection, if unspecified, use the default one
   */
   VrpnObject(std::string name, uint8_t id,
-             const gui::TabWidget *tab);
+             const gui::TabWidget *tab,sensor::VrpnClient *client=GetVrpnClient());
 
   /*!
Index: trunk/lib/FlairSensorActuator/src/VrpnObject_impl.cpp
===================================================================
--- trunk/lib/FlairSensorActuator/src/VrpnObject_impl.cpp	(revision 282)
+++ trunk/lib/FlairSensorActuator/src/VrpnObject_impl.cpp	(revision 286)
@@ -40,6 +40,6 @@
 
 VrpnObject_impl::VrpnObject_impl(VrpnObject *self,
-                                 string name, int id, const TabWidget *tab) {
-  parent = GetVrpnClient();
+                                 string name, int id, const TabWidget *tab,VrpnClient *client) {
+  parent = client;
   this->self = self;
 
Index: trunk/lib/FlairSensorActuator/src/unexported/VrpnObject_impl.h
===================================================================
--- trunk/lib/FlairSensorActuator/src/unexported/VrpnObject_impl.h	(revision 282)
+++ trunk/lib/FlairSensorActuator/src/unexported/VrpnObject_impl.h	(revision 286)
@@ -47,5 +47,5 @@
   VrpnObject_impl(flair::sensor::VrpnObject *self,
                   std::string name,
-                  int id, const flair::gui::TabWidget *tab);
+                  int id, const flair::gui::TabWidget *tab,flair::sensor::VrpnClient *client);
   ~VrpnObject_impl(void);
 
Index: trunk/lib/FlairSimulator/src/Blade.cpp
===================================================================
--- trunk/lib/FlairSimulator/src/Blade.cpp	(revision 282)
+++ trunk/lib/FlairSimulator/src/Blade.cpp	(revision 286)
@@ -64,4 +64,32 @@
 }
 
+Blade::Blade(ISceneNode *parent, const vector3df &position, bool inverted, s32 id)
+    : ISceneNode(parent, getGui()->getSceneManager(), id,
+                 position) {
+  ISceneManager *mgr = getGui()->getSceneManager();
+
+  const IGeometryCreator *geo;
+  geo = mgr->getGeometryCreator();
+  pale = geo->createCubeMesh(vector3df(63.5, 0.5, 5));
+
+  float angle;
+  if (inverted == false) {
+    angle = 20;
+  } else {
+    angle = -20;
+  }
+
+  ITexture *texture = getGui()->getTexture("carbone.jpg");
+  pale_1 = new MeshSceneNode(parent, pale, vector3df(-30, 0, 0),
+                             vector3df(-angle + 90, 0, 0), texture);
+  pale_1->setParent(this);
+  pale_2 = new MeshSceneNode(parent, pale, vector3df(30, 0, 0),
+                             vector3df(angle + 90, 0, 0), texture);
+  pale_2->setParent(this);
+
+  anim = mgr->createRotationAnimator(vector3df(0.f, 0.f, 0.f));
+  addAnimator(anim);
+}
+
 void Blade::OnRegisterSceneNode() {
   if (IsVisible)
Index: trunk/lib/FlairSimulator/src/Blade.h
===================================================================
--- trunk/lib/FlairSimulator/src/Blade.h	(revision 282)
+++ trunk/lib/FlairSimulator/src/Blade.h	(revision 286)
@@ -36,4 +36,9 @@
         const irr::core::vector3df &position = irr::core::vector3df(0, 0, 0),
         bool inverted = false, irr::s32 id = -1);
+
+  Blade(irr::scene::ISceneNode *parent,
+        const irr::core::vector3df &position = irr::core::vector3df(0, 0, 0),
+        bool inverted = false, irr::s32 id = -1);
+  
   virtual void OnRegisterSceneNode(void);
   virtual void render(void);
Index: trunk/lib/FlairSimulator/src/GenericObject.cpp
===================================================================
--- trunk/lib/FlairSimulator/src/GenericObject.cpp	(revision 282)
+++ trunk/lib/FlairSimulator/src/GenericObject.cpp	(revision 286)
@@ -40,8 +40,8 @@
 {
 	meshSceneNode=getGui()->getSceneManager()->addMeshSceneNode(mesh);
-	
+	/*
   selector = getGui()->getSceneManager()->createTriangleSelector(mesh, meshSceneNode);
   meshSceneNode->setTriangleSelector(selector);
-	
+	*/
   meshSceneNode->setMaterialFlag(EMF_LIGHTING, false);
 
@@ -53,4 +53,7 @@
 ITriangleSelector *GenericObject::TriangleSelector(void) { return selector; }
 
+void GenericObject::setVisible(bool isVisible) {
+  meshSceneNode->setVisible(isVisible);
+}
 void GenericObject::setScale(float value) {
   meshSceneNode->setScale(vector3df(value, value, value));
Index: trunk/lib/FlairSimulator/src/Gui_impl.cpp
===================================================================
--- trunk/lib/FlairSimulator/src/Gui_impl.cpp	(revision 282)
+++ trunk/lib/FlairSimulator/src/Gui_impl.cpp	(revision 286)
@@ -94,5 +94,4 @@
   device->setResizable(false);
 
-  // font = device->getGUIEnvironment()->getBuiltInFont();
   driver = device->getVideoDriver();
   smgr = device->getSceneManager();
@@ -179,4 +178,14 @@
   int lastFPS = -1;
   int cam_id = 0;
+  ITexture* texture=0;
+  IGUIFont* font =0;
+  
+  if (!driver->queryFeature(video::EVDF_RENDER_TO_TARGET)) {
+    self->Warn("rendering to texture is not possible, axis will not be displayed\n");
+  } else {
+    texture= getGui()->getSceneManager()->getVideoDriver()->addRenderTargetTexture(dimension2d<u32>(128,128));
+    device->getGUIEnvironment()->addImage(texture,position2d<s32>(0,scene_height-texture->getSize().Height));
+    font = getGui()->getDevice()->getGUIEnvironment()->getFont((media_path+"/font/simu_axis_font.xml").c_str());
+  }
 
   receiver->SetModel(models.at(0));
@@ -242,19 +251,5 @@
     driver->setViewPort(core::rect<s32>(0, 0, scene_width, scene_height));
     smgr->drawAll(); // commente voir plus bas
-                     /*
-                 env->drawAll();
-                 if (font)
-                 {
-                                     font->draw(L"This demo shows that Irrlicht is also capable
-                 of drawing 2D graphics.",
-                                             core::rect<s32>(130,10,300,50),
-                                             video::SColor(255,255,255,255));
-                 }
-                 else
-                 {
-                 printf("err\n");
-                 }
-                 device->setWindowCaption(L"toto");*/
-
+                    
     if (dbtFile_r == NULL) {// mode normal
       for (size_t i = 0; i < models.size(); i++) {
@@ -263,8 +258,15 @@
     }
 
+    //render to texture for axis if possible
+    if (texture) {
+      cameras.at(cam_id)->renderAxisToTexture(texture);
+    }
+    
+    //process update for sensors (cam, us...)
+    //also draws embedded cameras (see SimuCameraGL::UpdateFrom) 
     for (size_t i = 0; i < models.size(); i++) {
       models.at(i)->ProcessUpdate(NULL);
     }
-
+    
     // on fait ca ici, devrait etre un peu plus haut
     // mais a priori souci avec models.at(i)->pimpl_->CheckCollision();
@@ -274,7 +276,16 @@
     driver->setViewPort(core::rect<s32>(0, 0, scene_width, scene_height));
     smgr->drawAll();
-
+    
+    driver->setViewPort(core::rect<s32>(0, 0, smgr->getVideoDriver()->getScreenSize().Width, smgr->getVideoDriver()->getScreenSize().Height));
+    if(font) {
+      font->draw(L"VRPN:",rect<s32>(10,scene_height-30,100,50),SColor(128,255,255,255));
+      font->draw(L"X",rect<s32>(60,scene_height-30,100,50),SColor(255,255,0,0));
+      font->draw(L"Y",rect<s32>(70,scene_height-30,100,50),SColor(255,0,255,0));
+      font->draw(L"Z",rect<s32>(80,scene_height-30,100,50),SColor(255,0,0,255));
+      
+    }
+    device->getGUIEnvironment()->drawAll();
     driver->endScene();
-
+    
     int fps = driver->getFPS();
 
Index: trunk/lib/FlairSimulator/src/MeshSceneNode.cpp
===================================================================
--- trunk/lib/FlairSimulator/src/MeshSceneNode.cpp	(revision 282)
+++ trunk/lib/FlairSimulator/src/MeshSceneNode.cpp	(revision 286)
@@ -49,4 +49,22 @@
 }
 
+MeshSceneNode::MeshSceneNode(ISceneNode *parent, IMesh *mesh,
+                             const vector3df &position,
+                             const vector3df &rotation, ITexture *texture,
+                             s32 id)
+    : IMeshSceneNode(parent, getGui()->getSceneManager(), id,
+                     position, rotation) {
+  Material.Wireframe = false;
+  Material.Lighting = false;
+
+  setMesh(mesh);
+
+  if (texture != NULL) {
+    setMaterialTexture(0, texture);
+  }
+
+  //parent->getBoundingBox().addInternalBox(getTransformedBoundingBox());
+}
+
 void MeshSceneNode::OnRegisterSceneNode(void) {
   if (IsVisible)
Index: trunk/lib/FlairSimulator/src/MeshSceneNode.h
===================================================================
--- trunk/lib/FlairSimulator/src/MeshSceneNode.h	(revision 282)
+++ trunk/lib/FlairSimulator/src/MeshSceneNode.h	(revision 286)
@@ -31,4 +31,10 @@
       const irr::core::vector3df &rotation = irr::core::vector3df(0, 0, 0),
       irr::video::ITexture *texture = NULL, irr::s32 id = -1);
+  
+  MeshSceneNode(
+      irr::scene::ISceneNode *parent, irr::scene::IMesh *mesh,
+      const irr::core::vector3df &position = irr::core::vector3df(0, 0, 0),
+      const irr::core::vector3df &rotation = irr::core::vector3df(0, 0, 0),
+      irr::video::ITexture *texture = NULL, irr::s32 id = -1);
 
   virtual void OnRegisterSceneNode(void);
Index: trunk/lib/FlairSimulator/src/SimuBldc.cpp
===================================================================
--- trunk/lib/FlairSimulator/src/SimuBldc.cpp	(revision 282)
+++ trunk/lib/FlairSimulator/src/SimuBldc.cpp	(revision 286)
@@ -73,4 +73,4 @@
 }
 
-} // end namespace sensor
+} // end namespace actuator
 } // end namespace flair
Index: trunk/lib/FlairSimulator/src/Simulator.cpp
===================================================================
--- trunk/lib/FlairSimulator/src/Simulator.cpp	(revision 282)
+++ trunk/lib/FlairSimulator/src/Simulator.cpp	(revision 286)
@@ -36,10 +36,10 @@
 Simulator *getSimulator(void) { return simu; }
 
-Simulator::Simulator(string name, int optitrack_mstime, float yaw_deg)
+Simulator::Simulator(string name, int optitrack_mstime, float yaw_deg, int port)
     : FrameworkManager(name) {
   if (simu != NULL)
     Err("Simulator should be instanced only one time\n");
 
-  pimpl_ = new Simulator_impl(this, optitrack_mstime, yaw_deg);
+  pimpl_ = new Simulator_impl(this, optitrack_mstime, yaw_deg,port);
   simu = this;
 }
Index: trunk/lib/FlairSimulator/src/Simulator.h
===================================================================
--- trunk/lib/FlairSimulator/src/Simulator.h	(revision 282)
+++ trunk/lib/FlairSimulator/src/Simulator.h	(revision 286)
@@ -44,5 +44,5 @@
   // yaw_deg: rotation of the vrpn coordinate with respect to the earth
   // coordinate, around z axis
-  Simulator(std::string name, int optitrack_mstime = 10, float yaw_deg = 30);
+  Simulator(std::string name, int optitrack_mstime = 10, float yaw_deg = 30, int port=3883);
   ~Simulator();
   void RunSimu(void);
